"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpQueuePublisher = void 0;
const AbstractAmqpPublisher_1 = require("./AbstractAmqpPublisher");
const amqpQueueUtils_1 = require("./utils/amqpQueueUtils");
const NO_PARAMS = {
    publishOptions: {},
};
class AbstractAmqpQueuePublisher extends AbstractAmqpPublisher_1.AbstractAmqpPublisher {
    publishInternal(message, options) {
        this.channel.sendToQueue(this.queueName, message, options.publishOptions);
    }
    publish(message, options = NO_PARAMS) {
        super.publish(message, options);
    }
    createMissingEntities() {
        return (0, amqpQueueUtils_1.ensureAmqpQueue)(this.connection, this.channel, this.creationConfig, this.locatorConfig);
    }
}
exports.AbstractAmqpQueuePublisher = AbstractAmqpQueuePublisher;
//# sourceMappingURL=AbstractAmqpQueuePublisher.js.map