"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmqpExchangePublisherManager = void 0;
const core_1 = require("@message-queue-toolkit/core");
const CommonAmqpPublisherFactory_1 = require("./CommonAmqpPublisherFactory");
class AmqpExchangePublisherManager extends core_1.AbstractPublisherManager {
    constructor(dependencies, options) {
        super({
            isAsync: false,
            eventRegistry: dependencies.eventRegistry,
            metadataField: options.metadataField ?? 'metadata',
            metadataFiller: options.metadataFiller,
            newPublisherOptions: options.newPublisherOptions,
            publisherDependencies: {
                amqpConnectionManager: dependencies.amqpConnectionManager,
                logger: dependencies.logger,
                errorReporter: dependencies.errorReporter,
            },
            publisherFactory: options.publisherFactory ?? new CommonAmqpPublisherFactory_1.CommonAmqpExchangePublisherFactory(),
        });
    }
    resolvePublisherConfigOverrides(exchange) {
        return {
            exchange,
        };
    }
    resolveCreationConfig(queueName) {
        return {
            ...this.newPublisherOptions,
            queueOptions: {},
            queueName,
        };
    }
    publish(eventTarget, message, precedingEventMetadata, messageOptions) {
        return super.publish(eventTarget, message, precedingEventMetadata, messageOptions);
    }
    resolveEventTarget(event) {
        return event.queueName;
    }
}
exports.AmqpExchangePublisherManager = AmqpExchangePublisherManager;
//# sourceMappingURL=AmqpExchangePublisherManager.js.map